diff -Nur tmp1/AUTHORS tmp2/AUTHORS
--- tmp1/AUTHORS	1970-01-01 01:00:00.000000000 +0100
+++ tmp2/AUTHORS	2009-04-20 00:33:34.000000000 +0200
@@ -0,0 +1,9 @@
+
+David Courtney, Developer, dacourtney at users.sourceforge.net
+Mateusz Loskot, Developer, mloskot at users.sourceforge.net
+Maciej Sobczak, Admin Project Manager, msobczak at users.sourceforge.net
+Pawel Aleksander Fedorynski, Developer, pfedor at users.sourceforge.net
+Rafal Bobrowski, Developer, rbobro at users.sourceforge.net
+Jean-Marc, Developer, sidjtal at users.sourceforge.net
+Stephen Hutton, Developer, stephenhutton at users.sourceforge.net
+
diff -Nur tmp1/autogen.sh tmp2/autogen.sh
--- tmp1/autogen.sh	2009-04-20 00:33:34.000000000 +0200
+++ tmp2/autogen.sh	2009-04-20 00:33:34.000000000 +0200
@@ -1,69 +1,40 @@
-#!/bin/sh
-# $Id: autogen.sh,v 1.3 2008/05/28 20:05:17 mloskot Exp $
+#! /bin/sh
+
+# $Id: autogen.sh,v 1.4 2002/12/02 01:39:49 murrayc Exp $
 #
-# Run this to generate all the initial makefiles, etc.
-# This was lifted from the Gimp, and adapted slightly
-# by Raph Levien
+# Copyright (c) 2002  Daniel Elstner  <daniel.elstner@gmx.net>
 #
-# Customized for C++/Tk by Mateusz Loskot <mateusz@loskot.net>
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License VERSION 2 as
+# published by the Free Software Foundation.  You are not allowed to
+# use any other version of the license; unless you got the explicit
+# permission from the author to do so.
 #
-DIE=0
-
-PROJECT="SOCI"
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-for libtoolize in glibtoolize libtoolize; do
-    LIBTOOLIZE=`which $libtoolize 2>/dev/null`
-    if test -x "$LIBTOOLIZE"; then
-        break;
-    fi
-done
 
-if test -d "autom4te.cache"; then
-    rm -rf autom4te.cache
+dir=`echo "$0" | sed 's,[^/]*$,,'`
+test "x${dir}" = "x" && dir='.'
+
+if test "x`cd "${dir}" 2>/dev/null && pwd`" != "x`pwd`"
+then
+    echo "This script must be executed directly from the source directory."
+    exit 1
 fi
 
-(autoconf --version) < /dev/null > /dev/null 2>&1 || {
-	echo "Error:"
-	echo "You must have autoconf installed to compile $PROJECT."
-	echo "Get latest version from ftp://ftp.gnu.org/pub/gnu/autoconf/"
-	DIE=1
-}
-
-($LIBTOOLIZE --version) < /dev/null > /dev/null 2>&1 || {
-	echo "Error:"
-	echo "You must have libtool installed to compile $PROJECT."
-	echo "Get latest version from ftp://ftp.gnu.org/pub/gnu/libtool/"
-	DIE=1
-}
-
-(automake --version) < /dev/null > /dev/null 2>&1 || {
-	echo "Error:"
-	echo "You must have automake installed to compile $PROJECT."
-	echo "Get latest version from ftp://ftp.gnu.org/pub/gnu/automake/"
-	DIE=1
-}
-
-(aclocal --version) < /dev/null > /dev/null 2>&1 || {
-	echo "Error:"
-	echo "You must have aclocal installed to compile $PROJECT."
-    echo "aclocal is installed together with automake, so"
-	echo "get latest version from ftp://ftp.gnu.org/pub/gnu/automake/"
-	DIE=1
-}
-if test "$DIE" -eq 1; then
-	exit 1
-fi
+rm -f config.cache acconfig.h
+
+echo "- autoreconf."     	&& \
+autoreconf -fvi          	&& \
+echo "- configure."		&& \
+./configure "$@"		&& exit 0
 
-echo "Running aclocal..."
-aclocal -I m4
-echo "Running libtoolize..."
-$LIBTOOLIZE --force --copy
-echo "Running automake..."
-automake --add-missing --copy
-echo "Running autoconf..."
-autoconf
-
-echo
-echo "Now type './configure' to generate Makefile files for $PROJECT."
-echo "Run './configure --help' to get list of possible options."
+exit 1
 
diff -Nur tmp1/configure.ac tmp2/configure.ac
--- tmp1/configure.ac	2009-04-20 00:33:34.000000000 +0200
+++ tmp2/configure.ac	2009-04-20 00:33:34.000000000 +0200
@@ -1,276 +1,151 @@
-dnl $Id: configure.in,v 1.12 2009/04/18 19:57:33 mloskot Exp $
-dnl
-dnl Copyright (C) 2006, Mateusz Loskot
-dnl
-dnl Author: Mateusz Loskot <mateusz@loskot.net>
-dnl
-dnl -------------------------------------------------------------------
-dnl SOCI version information
-dnl -------------------------------------------------------------------
-dnl 
-dnl How to make a release:
-dnl 1. Increment by 1 these macros:
-dnl    soci_version_micro, cpptk_interface_age, cpptk_binary_age.
-dnl 2. If new functions have been added, set cpptk_interface_age to 0.
-dnl 3. If backwards compatibility has been broken, set cpptk_binary_age
-dnl    and cpptk_interface_age to 0.
-dnl -------------------------------------------------------------------
-m4_define([soci_version_major], [3])
-m4_define([soci_version_minor], [0])
-m4_define([soci_version_micro], [0])
-m4_define([soci_version],
-          [soci_version_major.soci_version_minor.soci_version_micro])
-
-dnl NOTE: Not used, because SOCI does not libtool's versioning system.
-m4_define([cpptk_interface_age], [0])
-m4_define([cpptk_binary_age], [0])
-
-
-dnl -------------------------------------------------------------------
-dnl *** DO NOT MODIFY ANYTHING BELOW THIS LINE ***
-dnl -------------------------------------------------------------------
-
-
-dnl -------------------------------------------------------------------
-dnl Autoconf initialization
-dnl -------------------------------------------------------------------
-AC_INIT([SOCI],
-        [soci_version],
-        [http://sourceforge.net/projects/soci],
-        [soci])
-
-
-dnl -------------------------------------------------------------------
-dnl C++/Tk release version (used by libtool's --release)
-dnl -------------------------------------------------------------------
-RELEASE_MAJOR=soci_version_major
-RELEASE_MINOR=soci_version_minor
-RELEASE_MICRO=soci_version_micro
-RELEASE_VERSION=soci_version
-
-AC_SUBST(RELEASE_MAJOR)
-AC_SUBST(RELEASE_MINOR)
-AC_SUBST(RELEASE_MICRO)
-AC_SUBST(RELEASE_VERSION)
-
-LIBTOOL_RELEASE="soci_version"
-AC_SUBST(LIBTOOL_RELEASE)
-
-dnl SOCI library version string after Boost naming convention
-SOCI_LIBRARY_VERSION="${RELEASE_MAJOR}_${RELEASE_MINOR}"
-
-
-dnl -------------------------------------------------------------------
-dnl Libtool versioning (used by libtool's --version-info)
-dnl
-dnl NOTE - mloskot:
-dnl We don't use libtool's API versioning system,
-dnl and there are no plans to use it in near future.
-dnl -------------------------------------------------------------------
-dnl m4_define([lt_current],
-dnl           [m4_eval(soci_version_micro - cpptk_interface_age)])
-dnl m4_define([lt_revision],
-dnl           [cpptk_interface_age])
-dnl m4_define([lt_age],
-dnl           [m4_eval(cpptk_binary_age - cpptk_interface_age)])
-dnl 
-dnl LIBTOOL_VERSION="lt_current:lt_revision:lt_age"
-dnl AC_SUBST(LIBTOOL_VERSION)
-
-
-dnl -------------------------------------------------------------------
-dnl Automake initialization
-dnl -------------------------------------------------------------------
+# Process this file with autoconf to produce a configure script
+#-------------------------------------------------------------------
+AC_PREREQ(2.59)
+AC_COPYRIGHT([Copyright (C) 2004-2009 Maciej Sobczak <msobczak@users.sourceforge.net>])
+AC_INIT([SOCI],[3.1.0],[msobczak@users.sourceforge.net],[soci])
+AC_CONFIG_HEADER([soci/config.h])
+AC_CONFIG_SRCDIR([soci/core/error.cpp])
+AC_CONFIG_AUX_DIR([config])
 AM_INIT_AUTOMAKE
+AM_PATH_CPPUNIT(1.10)
+AM_CONDITIONAL([HAVE_CPPUNIT], [test "x$CPPUNIT_LIBS" != x])
 
-dnl -------------------------------------------------------------------
-dnl Check which system we're building for
-dnl -------------------------------------------------------------------
-AC_CANONICAL_HOST
+# RPM release number
+RPM_RELEASE="4"
+AC_SUBST(RPM_RELEASE)
+
+# Shared library versioning
+GENERIC_LIBRARY_VERSION="3:1:0"
+#                        | | |
+#                 +------+ | +---+
+#                 |        |     |
+#              current:revision:age
+#                 |        |     |
+#                 |        |     +- increment if interfaces have been added;
+#                 |        |        set to zero if interfaces have been 
+#                 |        |        removed or changed
+#                 |        +- increment if source code has changed;
+#                 |           set to zero if current is incremented
+#                 +- increment if interfaces have been added, removed
+#                    or changed
+AC_SUBST(GENERIC_LIBRARY_VERSION)
+
+# Upload command for SourceForge
+UPLOAD_COMMAND="ncftpput -v upload.sourceforge.net /incoming"
+AC_SUBST(UPLOAD_COMMAND)
 
-case $host_os in
-    *mingw32* ) WIN32=yes ;;
-    *cygwin* )  WIN32=yes ;;
-    *) WIN32=no ;;
+# Check for host and disable building a shared library in Windows
+AC_CANONICAL_HOST
+case $host in
+  *-*-msdos* | *-*-go32* | *-*-mingw32* | *-*-cygwin* | *-*-windows*) 
+    AC_DISABLE_SHARED
+    AC_ENABLE_STATIC
+    ;;
+  *)  
+    AC_ENABLE_SHARED
+    AC_DISABLE_STATIC
+    ;;
 esac
 
-if test "$WIN32" = "no"
-then
-    LD_LIB="-ldl"
-else
-    LD_LIB=""
-fi
-AC_SUBST(LD_LIB)
-
-
-dnl -------------------------------------------------------------------
-dnl Check C++ capabilities
-dnl -------------------------------------------------------------------
-
-dnl Hack to get rid of setting -g -02 together, but let's user set
-dnl these flags explicitly.
-if test -z ${CXXFLAGS}; then
-    CXXFLAGS=""
-fi
-
+# Checks for programs
+save_CXXFLAGS="$CXXFLAGS"
 AC_PROG_CXX
-AC_LANG_CPLUSPLUS
-
-
-dnl Detect compiler and configure toolset to use it in library names
-AX_CXX_TOOLSET
-
-SOCI_LIBRARY_TOOLSET="$CXX_TOOLSET_NAME"
-
-
-dnl -------------------------------------------------------------------
-dnl Check libtool
-dnl -------------------------------------------------------------------
-AM_PROG_LIBTOOL
-
-
-dnl -------------------------------------------------------------------
-dnl Check other tools
-dnl -------------------------------------------------------------------
-AC_PROG_MAKE_SET
+AC_PROG_CXXCPP
+CXXFLAGS="$save_CXXFLAGS"
 AC_PROG_INSTALL
+AC_PROG_LIBTOOL
+AC_PROG_LN_S
+AC_PROG_MAKE_SET
 
+# Set default language to C++
+AC_LANG([C++])
 
-dnl -------------------------------------------------------------------
-dnl Check Boost libraries
-dnl -------------------------------------------------------------------
-AX_BOOST_BASE([1.33.1])
-AX_BOOST_DATE_TIME
-
-if test ! -z "$BOOST_CPPFLAGS"; then
-    HAVE_BOOST="yes"
-else
-    HAVE_BOOST="no"
-fi
-
-if test ! -z "$BOOST_DATE_TIME_LIB"; then
-    HAVE_BOOST_DATE_TIME="yes"
-else
-    HAVE_BOOST_DATE_TIME="no"
-fi
-
-dnl -------------------------------------------------------------------
-dnl Set defaults
-dnl -------------------------------------------------------------------
-AC_PREFIX_DEFAULT([/usr/local])
-
-
-dnl --------------------------------------------------------------------
-dnl Set recommended default flags for compiler and linker
-dnl --------------------------------------------------------------------
-CXXFLAGS="${CXXFLAGS} -Wall -pedantic -Wno-long-long"
-
-
-dnl --------------------------------------------------------------------
-dnl Detect compilation mode: debug or release
-dnl --------------------------------------------------------------------
-AC_ARG_ENABLE([debug],
-    AC_HELP_STRING([--enable-debug=@<:@yes|no@:>@],
-        [enable debug build @<:@default=no@:>@]
-    ),
-	[
-    case "${enableval}" in
-		yes) SOCI_BUILD_DEBUG="yes" ;;
-		no)  SOCI_BUILD_DEBUG="no" ;;
-		*) AC_MSG_ERROR(bad value ${enableval} for --enable-debug);;
-	esac
-    ],
-	[SOCI_BUILD_DEBUG="no"])
-
-dnl SOCI library naming is based on Boost convention, for more details see
-dnl http://www.boost.org/more/getting_started.html
-dnl
-dnl SOCI_LIBRARY_RUNTIME possible values: 
-dnl g - debug runtime
-dnl s - static runtime (optional or not used yet)
-dnl d - debug enabled (optional or not used yet)
-dnl
-if test "$SOCI_BUILD_DEBUG" = "yes"; then
-    SOCI_LIBRARY_RUNTIME="g"
-    CXXFLAGS="-g ${CXXFLAGS}"
-    CPPFLAGS="-D_DEBUG ${CPPFLAGS}"
-else
-    SOCI_LIBRARY_RUNTIME=""
-    CXXFLAGS="-O2 ${CXXFLAGS}"
-    CPPFLAGS="-U_DEBUG ${CPPFLAGS}"
-fi
-
-dnl --------------------------------------------------------------------
-dnl Detect assertions mode: enabled or disabled
-dnl --------------------------------------------------------------------
-AC_ARG_ENABLE([assert],
-    AC_HELP_STRING([--enable-assert=@<:@yes|no@:>@],
-        [enable assert macro @<:@default=yes@:>@]
-    ),
-	[
-    case "${enableval}" in
-		yes) SOCI_ENABLE_ASSERT="yes" ;;
-		no)  SOCI_ENABLE_ASSERT="no" ;;
-		*) AC_MSG_ERROR(bad value ${enableval} for --enable-assert);;
-	esac
-    ],
-	[SOCI_ENABLE_ASSERT="yes"])
-
-if test "$SOCI_ENABLE_ASSERT" = "yes"; then
-    CPPFLAGS="-UNDEBUG ${CPPFLAGS}"
-else
-    CPPFLAGS="-DNDEBUG ${CPPFLAGS}"
-fi
-
-dnl -------------------------------------------------------------------
-dnl SOCI library names
-dnl -------------------------------------------------------------------
-
-dnl Common library prefix
-SOCI_LIBRARY_PREFIX="soci"
-
-dnl Common library suffix
-dnl
-dnl TODO - mloskot: Add support of 's' and 'd' runtime modes.
-dnl 
-if test -z "${SOCI_LIBRARY_RUNTIME}"; then
-    SOCI_LIBRARY_SUFFIX="${SOCI_LIBRARY_TOOLSET}-${SOCI_LIBRARY_VERSION}"
+# Check for exceptions switch
+AC_ARG_ENABLE(exceptions,
+              [AS_HELP_STRING([--enable-exceptions],
+                              [enable exceptions handling mechanism])],
+              [AC_DEFINE([SOCI_EXCEPTIONS], [1],
+                         [Define if you want exceptions handling])])
+test "x$enable_exceptions" != xno && enable_exceptions=yes
+test "x$ax_cv_boost_date_time" != xno && enable_exceptions=yes
+
+# Check for info pages
+AC_ARG_ENABLE(info-doc, 
+              [AS_HELP_STRING([--disable-info-doc],
+                              [do not generate Info documentation])])
+test "x$enable_info_doc" != xno && enable_info_doc=yes
+
+
+# Check for NLS switch
+AC_ARG_ENABLE(nls, 
+              [AS_HELP_STRING([--enable-nls],
+                              [do not generate NLS documentation])])
+test "x$enable_nls" != xyes && enable_nls=no
+
+
+# Check for html-doc switch
+AC_ARG_ENABLE(html-doc, 
+              [AS_HELP_STRING([--disable-html-doc],
+                              [do not generate HTML documentation])])
+test "x$enable_html_doc" != xno && enable_html_doc=yes
+
+
+# Provide --with-docdir
+AC_ARG_WITH(docdir,
+            [AS_HELP_STRING([--with-docdir=DIR],
+                            [set documentation directory to DIR])],
+            [DOC_DIR="$withval"],
+            [DOC_DIR=""])
+if test "x$DOC_DIR" != x; then
+  docdir="$DOC_DIR"
 else
-    SOCI_LIBRARY_SUFFIX="${SOCI_LIBRARY_TOOLSET}-${SOCI_LIBRARY_RUNTIME}-${SOCI_LIBRARY_VERSION}"
+  docdir="${datadir}/doc/$PACKAGE-$VERSION"
 fi
-
-SOCI_CORE_LIBRARY_NAME="${SOCI_LIBRARY_PREFIX}_core-${SOCI_LIBRARY_SUFFIX}"
-SOCI_EMPTY_LIBRARY_NAME="${SOCI_LIBRARY_PREFIX}_empty-${SOCI_LIBRARY_SUFFIX}"
-SOCI_FIREBIRD_LIBRARY_NAME="${SOCI_LIBRARY_PREFIX}_firebird-${SOCI_LIBRARY_SUFFIX}"
-SOCI_MYSQL_LIBRARY_NAME="${SOCI_LIBRARY_PREFIX}_mysql-${SOCI_LIBRARY_SUFFIX}"
-SOCI_ORACLE_LIBRARY_NAME="${SOCI_LIBRARY_PREFIX}_oracle-${SOCI_LIBRARY_SUFFIX}"
-SOCI_ODBC_LIBRARY_NAME="${SOCI_LIBRARY_PREFIX}_odbc-${SOCI_LIBRARY_SUFFIX}"
-SOCI_POSTGRESQL_LIBRARY_NAME="${SOCI_LIBRARY_PREFIX}_postgresql-${SOCI_LIBRARY_SUFFIX}"
-SOCI_SQLITE3_LIBRARY_NAME="${SOCI_LIBRARY_PREFIX}_sqlite3-${SOCI_LIBRARY_SUFFIX}"
-
-AC_SUBST([SOCI_CORE_LIBRARY_NAME])
-AC_SUBST([SOCI_EMPTY_LIBRARY_NAME])
-AC_SUBST([SOCI_FIREBIRD_LIBRARY_NAME])
-AC_SUBST([SOCI_MYSQL_LIBRARY_NAME])
-AC_SUBST([SOCI_ORACLE_LIBRARY_NAME])
-AC_SUBST([SOCI_ODBC_LIBRARY_NAME])
-AC_SUBST([SOCI_POSTGRESQL_LIBRARY_NAME])
-AC_SUBST([SOCI_SQLITE3_LIBRARY_NAME])
+AC_SUBST(docdir)
 
 
-dnl -------------------------------------------------------------------
-dnl Empty backend
-dnl
-dnl NOTE: Empty backend is always built-in
-dnl -------------------------------------------------------------------
+# Check for burried header files (for SOCI itself)
+AC_ARG_ENABLE(burried-headers, 
+              [AS_HELP_STRING([--disable-burried-headers],
+                              [include header files from a flat directory structure])])
+test "x$enable_burried_headers" != xno && enable_burried_headers=yes
+AM_CONDITIONAL([SOCI_HEADERS_BURIED], [test "x$enable_burried_headers" = xyes])
+AC_SUBST(SOCI_HEADERS_BURIED)
+CPPFLAGS="-DSOCI_HEADERS_BURIED $CPPFLAGS"
+
+# Check for burried header files (for MySQL client)
+AC_ARG_ENABLE(mysql-burried-headers, 
+              [AS_HELP_STRING([--disable-mysql-burried-headers],
+                              [include MySQL header files from a flat directory structure])])
+test "x$enable_mysql_burried_headers" != xno && enable_mysql_burried_headers=yes
+AM_CONDITIONAL([SOCI_MYSQL_HEADERS_BURIED],
+               [test "x$enable_mysql_burried_headers" = xyes])
+AC_SUBST(SOCI_MYSQL_HEADERS_BURIED)
+CPPFLAGS="-DSOCI_MYSQL_HEADERS_BURIED $CPPFLAGS"
+
+
+# --------------------------------------------------------
+# Boost (STL Extensions: http://www.boost.org)
+# --------------------------------------------------------
+AX_BOOST([1.33])
+AC_SUBST(BOOST_VERSION)
+AC_SUBST(BOOST_CFLAGS)
+AC_SUBST(BOOST_LIBS)
+AC_SUBST(BOOST_DATE_TIME_LIB)
+AC_SUBST(BOOST_PROGRAM_OPTIONS_LIB)
+
+# -------------------------------------------------------------------
+# Empty backend
+#
+# NOTE: Empty backend is always built-in
+# -------------------------------------------------------------------
 WANT_BACKEND_EMPTY="yes"
-EMPTY_DIRS="empty empty/test"
+EMPTY_DIRS="empty"
 AC_SUBST([EMPTY_DIRS])
 
-
-dnl -------------------------------------------------------------------
-dnl Firebird backend
-dnl -------------------------------------------------------------------
+# -------------------------------------------------------------------
+# Support for Firebird backend
+# -------------------------------------------------------------------
 AC_ARG_ENABLE([backend-firebird],
     AC_HELP_STRING([--enable-backend-firebird=@<:@yes|no@:>@],
         [build-in Firebird backend support @<:@default=no@:>@]
@@ -286,16 +161,16 @@
     AX_LIB_FIREBIRD($FIREBIRD_REQ_VERSION)
 
     if test -n "$FIREBIRD_CFLAGS" -a -n "$FIREBIRD_LDFLAGS"; then
-        FIREBIRD_DIRS="firebird firebird/test"
+        FIREBIRD_DIRS="firebird"
     fi
 fi
+AM_CONDITIONAL([HAVE_FIREBIRD], [test "x$WANT_BACKEND_FIREBIRD" = xyes])
 
 AC_SUBST([FIREBIRD_DIRS])
 
-
-dnl -------------------------------------------------------------------
-dnl MySQL backend
-dnl -------------------------------------------------------------------
+# --------------------------------------------------------------------
+# Support for MySQL backend (C client API): http://www.mysql.org
+# --------------------------------------------------------------------
 AC_ARG_ENABLE([backend-mysql],
     AC_HELP_STRING([--enable-backend-mysql=@<:@yes|no@:>@],
         [build-in MySQL backend support @<:@default=no@:>@]
@@ -305,15 +180,19 @@
 )
 
 MYSQL_DIRS=""
+WANT_BACKEND_MYSQL="yes"
 if test "$WANT_BACKEND_MYSQL" = "yes"; then
 
     MYSQL_REQ_VERSION="3.0.0"
     AX_LIB_MYSQL([$MYSQL_REQ_VERSION])
 
     if test -n "$MYSQL_CFLAGS" -a -n "$MYSQL_LDFLAGS"; then
-        MYSQL_DIRS="mysql mysql/test"
+        MYSQL_DIRS="mysql"
     fi
 fi
+AM_CONDITIONAL([HAVE_MYSQL], [test "x$WANT_BACKEND_MYSQL" = xyes])
+WANT_BACKEND_MYSQL="yes"
+MYSQL_DIRS="mysql"
 
 AC_SUBST([MYSQL_DIRS])
 
@@ -339,16 +218,16 @@
     AX_LIB_ODBC([$ODBC_REQ_VERSION])
 
     if test -n "$ODBC_CFLAGS" -a -n "$ODBC_LDFLAGS"; then
-        ODBC_DIRS="odbc odbc/test"
+        ODBC_DIRS="odbc"
     fi
 fi
+AM_CONDITIONAL([HAVE_ODBC], [test "x$WANT_BACKEND_ODBC" = xyes])
 
 AC_SUBST([ODBC_DIRS])
 
-
-dnl -------------------------------------------------------------------
-dnl ORACLE backend
-dnl -------------------------------------------------------------------
+# -------------------------------------------------------------------
+# Support for Oracle backend
+# -------------------------------------------------------------------
 AC_ARG_ENABLE([backend-oracle],
     AC_HELP_STRING([--enable-backend-oracle=@<:@yes|no@:>@],
         [build-in ORACLE backend support @<:@default=no@:>@]
@@ -359,21 +238,22 @@
 
 ORACLE_DIRS=""
 if test "$WANT_BACKEND_ORACLE" = "yes"; then
-
     ORACLE_OCI_REQ_VERSION="9.0"
     AX_LIB_ORACLE_OCI($ORACLE_OCI_REQ_VERSION)
 
     if test -n "$ORACLE_OCI_CFLAGS" -a -n "$ORACLE_OCI_LDFLAGS"; then
-        ORACLE_DIRS="oracle oracle/test"
+        ORACLE_DIRS="oracle"
     fi
 fi
+AM_CONDITIONAL([HAVE_ORACLE], [test "x$WANT_BACKEND_ORACLE" = xyes])
+WANT_BACKEND_ORACLE="yes"
+ORACLE_DIRS="oracle"
 
 AC_SUBST([ORACLE_DIRS])
 
-
-dnl -------------------------------------------------------------------
-dnl PostgreSQL backend
-dnl -------------------------------------------------------------------
+# -------------------------------------------------------------------
+# Support for PostgreSQL backend
+# -------------------------------------------------------------------
 AC_ARG_ENABLE([backend-postgresql],
     AC_HELP_STRING([--enable-backend-postgresql=@<:@yes|no@:>@],
         [build-in PostgreSQL backend support @<:@default=no@:>@]
@@ -389,16 +269,19 @@
     AX_LIB_POSTGRESQL($POSTGRESQL_REQ_VERSION)
 
     if test -n "$POSTGRESQL_CFLAGS" -a -n "$POSTGRESQL_LDFLAGS"; then
-        POSTGRESQL_DIRS="postgresql postgresql/test"
+        POSTGRESQL_DIRS="postgresql"
     fi
 fi
+AM_CONDITIONAL([HAVE_POSTGRESQL], [test "x$WANT_BACKEND_POSTGRESQL" = xyes])
+WANT_BACKEND_POSTGRESQL="yes"
+POSTGRESQL_DIRS="postgresql"
 
 AC_SUBST([POSTGRESQL_DIRS])
 
 
-dnl -------------------------------------------------------------------
-dnl SQLite 3 backend
-dnl -------------------------------------------------------------------
+# -------------------------------------------------------------------
+# Support for SQLite 3 backend
+# -------------------------------------------------------------------
 AC_ARG_ENABLE([backend-sqlite3],
     AC_HELP_STRING([--enable-backend-sqlite3=@<:@yes|no@:>@],
         [build-in SQLite 3 backend support @<:@default=no@:>@]
